
;---------------------------------------------------------------------------  
; BIOS Working Segment
;--------------------------------------------------------------------------- 

BIOSSEG		.EQU	$010000
BIOSWKB		.EQU	.SEG.TOSSEG	; BIOS working bank
_BS		.SET	BIOSSEG
_BE		.SET	BIOSSEG + $FFFF
;;TO		.SET	TOSWKM

_BIOS:	.SECTION ref_only, common, offset _BS, range _BS _BE ;BIOS working area
_BIOS_START	.DS	0

_vram		.DS	$0800
_vattr		.DS	$0800
_vpal		.DS	$0400
_ioram		.DS	$0400
_ioram2		.DS	$0800

_xram		.DS	$2000

_dmasave	.DS	$4800	; save 36 fdc sec. ($4800)

;_atamod0	.DS	41	; model string device ata #0
;_ataser0	.DS	21	; serial string device ata #0
;_atarev0	.DS	9	; revision string device ata #0

;_atamod1	.DS	41	; model string device ata #1
;_ataser1	.DS	21	; serial string device ata #1
;_atarev1	.DS	9	; revision string device ata #1

;_usbdsc0	.DS	32	; identification string device usb #0
;_usbdsc1	.DS	32	; identification string device usb #1

_BIOS_END	.DS	0
BIOSSIZ		.EQU	(_BIOS_END - _BIOS_START)
.ENDS

;DMASEG		.EQU	$020000
;DMASWKB		.EQU	.SEG.DMASEG	; DMA working bank
;_DS		.SET	DMASEG
;_DE		.SET	DMASEG + $FFFF

;_DMAS1:	.SECTION ref_only, common, offset _DS, range _DS _DE ;DMA segment
;_clscache		.DS	$8000
;.ENDS
